<?php
/*
Plugin Name: XML Google Maps
Plugin URI: http://www.matusz.ch/blog/projekte/xml-google-maps-wordpress-plugin/
Feed URI: http://www.matusz.ch/blog/tags/xml-google-maps-wp-plugin/feed/
Description: This Plugin converts GPX, KML, KMZ or Google Maps Links directly to an completely integrated Google Map (supports Dfeault, Satellite, Hybrid, Physical and Google Earth Plugin Maptypes)
Version: 1.5
Author: Patrick Matusz
Author URI: http://www.matusz.ch/blog/
*/

global $wpdb;

$wpdb->xmlgooglemapsdb = $table_prefix . 'xmlgooglemaps';

// Defining Options
define("key_xmlgm_uid", "xmlgm_uid", true);
define("xmlgm_uid_default", "(none)", true);
define("key_xmlgm_width", "xmlgm_width", true);
define("xmlgm_width_default", "664", true);
define("key_xmlgm_height", "xmlgm_height", true);
define("xmlgm_height_default", "400", true);
define("key_xmlgm_align", "xmlgm_align", true);
define("xmlgm_align_default", "left", true);
define("key_xmlgm_urldisplaymode", "xmlgm_urldisplaymode", true);
define("xmlgm_urldisplaymode_default", "title", true);
define("key_xmlgm_viewstyle", "xmlgm_viewstyle", true);
define("xmlgm_viewstyle_default", "G_NORMAL_MAP", true);
define("key_xmlgm_panzoomcontrol", "xmlgm_panzoomcontrol", true);
define("xmlgm_panzoomcontrol_default", "large", true);
define("key_xmlgm_overviewmap", "xmlgm_overviewmap", true);
define("xmlgm_overviewmap_default", "hide", true);
define("key_xmlgm_scalecontrol", "xmlgm_scalecontrol", true);
define("xmlgm_scalecontrol_default", "hide", true);
define("key_xmlgm_maptypecontrol", "xmlgm_maptypecontrol", true);
define("xmlgm_maptypecontrol_default", "show", true);
define("key_xmlgm_mapnorm", "xmlgm_mapnorm", true);
define("xmlgm_mapnorm_default", "show", true);
define("key_xmlgm_maphyb", "xmlgm_maphyb", true);
define("xmlgm_maphyb_default", "show", true);
define("key_xmlgm_mapsat", "xmlgm_mapsat", true);
define("xmlgm_mapsat_default", "show", true);
define("key_xmlgm_mapphy", "xmlgm_mapphy", true);
define("xmlgm_mapphy_default", "hide", true);
define("key_xmlgm_mapearth", "xmlgm_mapearth", true);
define("xmlgm_mapearth_default", "hide", true);
define("key_xmlgm_dragging", "xmlgm_dragging", true);
define("xmlgm_dragging_default", "enabled", true);
define("key_xmlgm_doubleClickZoom", "xmlgm_doubleClickZoom", true);
define("xmlgm_doubleClickZoom_default", "enabled", true);
define("key_xmlgm_continuousZoom", "xmlgm_continuousZoom", true);
define("xmlgm_continuousZoom_default", "enabled", true);
define("key_xmlgm_googleBar", "xmlgm_googleBar", true);
define("xmlgm_googleBar_default", "disabled", true);
define("key_xmlgm_scrollWheelZoom", "xmlgm_scrollWheelZoom", true);
define("xmlgm_scrollWheelZoom_default", "enabled", true);
define("key_xmlgm_elevationmeasurement", "xmlgm_elevationmeasurement", true);
define("xmlgm_elevationmeasurement_default", "metric", true);
define("key_xmlgm_speedscale", "xmlgm_speedscale", true);
define("xmlgm_speedscale_default", "level2", true);

//GPX Options
define("key_xmlgm_linecolor", "xmlgm_linecolor", true);
define("xmlgm_linecolor_default", "#0000FF", true);
define("key_xmlgm_linewidth", "xmlgm_linewidth", true);
define("xmlgm_linewidth_default", "5", true);
define("key_xmlgm_lineopacity", "xmlgm_lineopacity", true);
define("xmlgm_lineopacity_default", "50", true);
define("key_xmlgm_gpxview", "xmlgm_gpxview", true);
define("xmlgm_gpxview_default", "all", true);
define("key_xmlgm_gpxcssstyle", "xmlgm_gpxcssstyle", true);
define("xmlgm_gpxcssstyle_default", "font-family: Verdana, Arial, Sans-Serif;", true);

//Elevation Options
define("key_xmlgm_elevationheight", "xmlgm_elevationheight", true);
define("xmlgm_elevationheight_default", "200", true);
define("key_xmlgm_elevlinecolor", "xmlgm_elevlinecolor", true);
define("xmlgm_elevlinecolor_default", "#0000FF", true);
define("key_xmlgm_elevationchart", "xmlgm_elevationchart", true);
define("xmlgm_elevationchart_default", "show", true);
define("key_xmlgm_elelinewidth", "xmlgm_elelinewidth", true);
define("xmlgm_elelinewidth_default", "5", true);
define("key_xmlgm_elevationtitle", "xmlgm_elevationtitle", true);
define("xmlgm_elevationtitle_default", "Elevation Profile", true);

//Speed Options
define("key_xmlgm_speedheight", "xmlgm_speedheight", true);
define("xmlgm_speedheight_default", "200", true);
define("key_xmlgm_speedlinecolor", "xmlgm_speedlinecolor", true);
define("xmlgm_speedlinecolor_default", "#0000FF", true);
define("key_xmlgm_speedchart", "xmlgm_speedchart", true);
define("xmlgm_speedchart_default", "hide", true);
define("key_xmlgm_speedlinewidth", "xmlgm_speedlinewidth", true);
define("xmlgm_speedlinewidth_default", "5", true);
define("key_xmlgm_speedcharttitle", "xmlgm_speedcharttitle", true);
define("xmlgm_speedcharttitle_default", "Speed Profile", true);

//Check Point Options
define("key_xmlgm_checkpointmapmarkercolor", "xmlgm_checkpointmapmarkercolor", true);
define("xmlgm_checkpointmapmarkercolor_default", "red", true);
define("key_xmlgm_checkpointtable", "xmlgm_checkpointtable", true);
define("xmlgm_checkpointtable_default", "hide", true);
define("key_xmlgm_checkpointinterval", "xmlgm_checkpointinterval", true);
define("xmlgm_checkpointinterval_default", "0", true);
define("key_xmlgm_checkpointtabletempl", "xmlgm_checkpointtabletempl", true);
define("xmlgm_checkpointtabletempl_default", "", true);
define("key_xmlgm_checkpointtablerowtempl", "xmlgm_checkpointtablerowtempl", true);
define("xmlgm_checkpointtablerowtempl_default", "", true);


add_option(key_xmlgm_dragging, xmlgm_dragging_default, 'Enables/Disables Dragging on Google Map');
add_option(key_xmlgm_doubleClickZoom, xmlgm_doubleClickZoom_default, 'Enables/Disables Double Click Zoom on Google Map');
add_option(key_xmlgm_continuousZoom, xmlgm_continuousZoom_default, 'Enables/Disables Continuous Zoom on Google Map');
add_option(key_xmlgm_googleBar, xmlgm_googleBar_default, 'Enables/Disables Google Bar on Google Map');
add_option(key_xmlgm_scrollWheelZoom, xmlgm_scrollWheelZoom_default, 'Enables/Disables Scroll Wheel Zoom on Google Map');
add_option(key_xmlgm_uid, xmlgm_uid_default, 'Your Google Maps API Key');
add_option(key_xmlgm_width, xmlgm_width_default, 'Width of your Google Map');
add_option(key_xmlgm_height, xmlgm_height_default, 'Height of your Google Map');
add_option(key_xmlgm_align, xmlgm_align_default, 'Align of your Google Map');
add_option(key_xmlgm_linecolor, xmlgm_linecolor_default, 'Default Line Color of Tracks and Routes');
add_option(key_xmlgm_urldisplaymode, xmlgm_urldisplaymode_default, 'Default display mode for URL');
add_option(key_xmlgm_viewstyle, xmlgm_viewstyle_default, 'Default style for MAP');
add_option(key_xmlgm_linewidth, xmlgm_linewidth_default, 'Default Line Width of Tracks and Routes');
add_option(key_xmlgm_lineopacity, xmlgm_lineopacity_default, 'Default Line Opacity of Tracks and Routes');
add_option(key_xmlgm_gpxview, xmlgm_gpxview_default, 'Default GPX View Mode');
add_option(key_xmlgm_panzoomcontrol, xmlgm_panzoomcontrol_default, 'Pan/Zoom Control');
add_option(key_xmlgm_overviewmap, xmlgm_overviewmap_default, 'Overview Map Control');
add_option(key_xmlgm_scalecontrol, xmlgm_scalecontrol_default, 'Scale Control');
add_option(key_xmlgm_maptypecontrol, xmlgm_maptypecontrol_default, 'Map Type Control');
add_option(key_xmlgm_elevlinecolor, xmlgm_elevlinecolor_default, 'Elevation Chart Line Color');
add_option(key_xmlgm_elevationchart, xmlgm_elevationchart_default, 'Visibility of Elevation Chart');
add_option(key_xmlgm_elelinewidth, xmlgm_elelinewidth_default, 'Elevation Chart Line Width');
add_option(key_xmlgm_elevationheight, xmlgm_elevationheight_default, 'Height of Elevation Chart');
add_option(key_xmlgm_elevationmeasurement, xmlgm_elevationmeasurement_default, 'Measurement type everything');
add_option(key_xmlgm_gpxcssstyle, xmlgm_gpxcssstyle_default, 'GPX Waypoint CSS Style of Title and Description');
add_option(key_xmlgm_mapnorm, xmlgm_mapnorm_default, 'Shows/Hides Normal Map Button if Map Type Control is shown');
add_option(key_xmlgm_mapsat, xmlgm_mapsat_default, 'Shows/Hides Satellite Map Button if Map Type Control is shown');
add_option(key_xmlgm_maphyb, xmlgm_maphyb_default, 'Shows/Hides Hybrid Map Button if Map Type Control is shown');
add_option(key_xmlgm_mapphy, xmlgm_mapphy_default, 'Shows/Hides Physical Map Button if Map Type Control is shown');
add_option(key_xmlgm_mapearth, xmlgm_mapearth_default, 'Shows/Hides Google Earth Map Button if Map Type Control is shown');
add_option(key_xmlgm_speedlinecolor, xmlgm_speedlinecolor_default, 'Speed Chart Line Color');
add_option(key_xmlgm_speedchart, xmlgm_speedchart_default, 'Visibility of Speed Chart');
add_option(key_xmlgm_speedlinewidth, xmlgm_speedlinewidth_default, 'Speed Chart Line Width');
add_option(key_xmlgm_speedheight, xmlgm_speedheight_default, 'Height of Speed Chart');
add_option(key_xmlgm_speedscale, xmlgm_speedscale_default, 'Speed Scale');
add_option(key_xmlgm_elevationtitle, xmlgm_elevationtitle_default, 'Title of Elevation Chart');
add_option(key_xmlgm_speedcharttitle, xmlgm_speedcharttitle_default, 'Title of Speed Chart');
add_option(key_xmlgm_checkpointmapmarkercolor, xmlgm_checkpointmapmarkercolor_default, 'Checkpoint Marker Color on map');
add_option(key_xmlgm_checkpointtable, xmlgm_checkpointtable_default, 'Shows/Hides a checkpoint table');
add_option(key_xmlgm_checkpointinterval, xmlgm_checkpointinterval_default, 'Defines the default Checkpoint Interval (0=hide)');
add_option(key_xmlgm_checkpointtablerowtempl, xmlgm_checkpointtablerowtempl_default, 'HTML Template for the Checkpoint Table Row');
add_option(key_xmlgm_checkpointtabletempl, xmlgm_checkpointtabletempl_default, 'HTML Template for the Checkpoint Table');

//Actions & Filters
add_filter('the_content', 'xmlgooglemaps_converter', 2);
add_filter('upload_mimes', 'xmlgooglemaps_mimes');
add_action('admin_menu', 'add_xmlgm_option_page');

//Add Option Page
function add_xmlgm_option_page() {
	global $wpdb;
	add_options_page('XML Google Maps Options', 'XML Google Maps', 8, basename(__FILE__), 'xmlgm_options_page');
}

function xmlgooglemaps_converter($content) {	
	global $wpdb;
	
	require_once(dirname(__FILE__).'/xmlgooglemaps_helper.php');	
	
	dbinstall();
	
	//$content = str_replace("\n","####nnnn####", $content);
	//$content = str_replace("\r","####rrrr####", $content);
		
	//GPX
	$content = xmlgooglemaps_converter_gpx($content);
	
	//KMX	
	$content = xmlgooglemaps_converter_kmx($content);
	
	// Google Maps Meine Karten: http://maps.google.com/maps/ms?ie=UTF8&hl=de&msa=0&output=nl&msid=102758581694521177745.00000111d56d20b14f816
	$content = xmlgooglemaps_converter_GoogleMaps($content);

	//XML Google Maps Parts
	$content = xmlgooglemaps_converter_myxmlgm($content);
	
	//$content = str_replace("####nnnn####","\n", $content);
	//$content = str_replace("####rrrr####","\r", $content);
	
	return $content;	
}

function xmlgooglemaps_mimes($mimes) {
	$mime_types = array ('gpx' => 'application/gpx', 'kml' => 'application/vnd.google-earth.kml+xml', 'kmz' => 'application/vnd.google-earth.kmz+xml');
    return array_merge($mimes,$mime_types);
}

function dbinstall() {
	global $wpdb;
	if (!gmxml_tableexists($wpdb->xmlgooglemapsdb)) {	
		$create_sql = "CREATE TABLE $wpdb->xmlgooglemapsdb (".
				"xml_id INT(11) NOT NULL auto_increment,".
				"xml_path TEXT NOT NULL ,".
				"xml_path_resolved TEXT NOT NULL ,".
				"PRIMARY KEY (xml_id))";
		$wpdb->query($create_sql);
	}
	if (!gmxml_columnexists($wpdb->xmlgooglemapsdb,"xml_varstring")) {
		$column_sql = "ALTER TABLE $wpdb->xmlgooglemapsdb ADD COLUMN xml_varstring TEXT NOT NULL;";
		$wpdb->query($column_sql);
	}	
}

function xmlgooglemaps_converter_GoogleMaps($content) {
		
	preg_match_all('/\<a(.*?)href=["\'](http:\/\/maps\.google\.[a-z]*\/maps\/ms[a-zA-Z0-9\/:\-\.,_?&=;]*?)["\'](.*?)\>(.*?)\<\/a\>/i', $content, $found);		

	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];
		$file = str_replace("&amp;","&",$file);
		$file_resolved = $file;
		
		$displayurl = $found[0][$i];
		$urlstring = $found[4][$i];
		
		$iurlstring = stripos($urlstring,"[");
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);
		} else {
			$varstring = "";
		}
		
		$params = new xml_gm_params();
		$params->setParams($varstring);		
		$displayurl = getDisplayURL($params->urlDisplayMode, $displayurl, $varstring);		
		
		$mygooglemapid = getid($file, $file_resolved, $varstring);
		
		$content = str_replace($found[0][$i],'<div style="text-align: '.$params->align.';"><iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?mygooglemapid='.$mygooglemapid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="Google_My_Map" frameborder="0"></iframe></div>'.$displayurl,$content);
	}	
	return $content;
}

function xmlgooglemaps_converter_kmx($content) {
	preg_match_all('/\<a(.*?)href=["\']([a-zA-Z0-9\/:\-\._]*?.km[lz])["\'](.*?)\>(.*?)\<\/a\>/i', $content, $found);
			
	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];
		
		$plugins=get_option('active_plugins');
		$pluginpath= "";
		for ($j=0; $j<count($plugins); $j++) {
			if (stripos($plugins[$j],"xmlgooglemaps.php") > 0) {
				$pluginpath = dirname(PLUGINDIR."/".$plugins[$j]);
				break;
			}
		}
		$surl = get_option('siteurl');
		$spath = preg_replace('|/'.$pluginpath.'.*|i', '', dirname(__FILE__));
	
		$file_resolved = $file;

		if (stripos($file,$surl)==0) {
			$newres = str_replace($surl,$spath,$file);
			if (file_exists($newres)) {
				$file_resolved = $newres;	
			}
		}

		$displayurl = $found[0][$i];
		$urlstring = $found[4][$i];
		$iurlstring = stripos($urlstring,"[");
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);
		} else {
			$varstring = "";
		}
		
		$params = new xml_gm_params();
		$params->setParams($varstring);
		$displayurl = getDisplayURL($params->urlDisplayMode, $displayurl, $varstring);				
				
		$kmlid = getid($file, $file_resolved, $varstring);
		
		$content = str_replace($found[0][$i],'<div style="text-align: '.$params->align.';"><iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?kmlid='.$kmlid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="Google_KML_Maps" frameborder="0"></iframe></div>'.$displayurl,$content);
	}
	return $content;
}

function xmlgooglemaps_converter_myxmlgm($content) {
	preg_match_all('/\[xmlgm(.*?)\]/i', $content, $found);
	for ($i=0; $i< count($found[0]);$i++) {
		$varstring = str_replace("[xmlgm","", $found[0][$i]);
		$varstring = str_replace("]","", $varstring);
		$varstring = trim($varstring);
				
		$params = new xml_gm_params();
		$params->setParams($varstring);			
		
		$myid = getid("", "", $varstring);
		
		$content = str_replace($found[0][$i],'<div style="text-align: '.$params->align.';"><iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?myid='.$myid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="My_XML_Google_Maps" frameborder="0"></iframe></div>',$content);
	}
	
	return $content;
}

function xmlgooglemaps_converter_gpx($content) {
	preg_match_all('/\<a(.*?)href=["\']([a-zA-Z0-9\/:\-\._]*?.gpx)["\'](.*?)\>(.*?)\<\/a\>/i', $content, $found);
	//preg_match_all('/\<a([^\>]*?)href=["\']([a-zA-Z0-9\/:\-\._]*?.gpx)["\']([^\>]*?)\>(.*?)\<\/a\>/i', $content, $found);
	//	print("<!-- ");
	//	print_r($found);
	//	print(" -->");
	for ($i=0; $i< count($found[0]);$i++) {
		$file = $found[2][$i];
		
		$plugins=get_option('active_plugins');
		$pluginpath= "";
		for ($j=0; $j<count($plugins); $j++) {
			if (stripos($plugins[$j],"xmlgooglemaps.php") > 0) {
				$pluginpath = dirname(PLUGINDIR."/".$plugins[$j]);
				break;
			}
		}
		$surl = get_option('siteurl');
		$spath = preg_replace('|/'.$pluginpath.'.*|i', '', dirname(__FILE__));
		
		$file_resolved = $file;
		if (stripos($file,$surl)==0) {
			$newres = str_replace($surl,$spath,$file);
			if (file_exists($newres)) {
				$file_resolved = $newres;	
			}
		}
				
		$urlstring = $found[4][$i];
		$iurlstring = stripos($urlstring,"[");
		$displayurl = $found[0][$i];
		if ($iurlstring !== false) {
			$jurlstring = stripos($urlstring,"]",$iurlstring);
			$iurlstring += 1;
			$varstring = substr($urlstring, $iurlstring, $jurlstring-$iurlstring);			
		} else {
			$varstring = "";
		}		
		
		$params = new xml_gm_params();
		$params->setParams($varstring);		
		$displayurl = getDisplayURL($params->urlDisplayMode, $displayurl, $varstring);		
		
		$gpxid = getid($file, $file_resolved, $varstring);
		
		//Altitudes / Speed Charts
		$altstring = "";
		$speedstring = "";
		$cptabstring = "";
		if (($params->gpxElevationChart == "show") || ($params->gpxSpeedChart == "show") || ($params->gpxCheckpointTable == "show") ) {
			require_once(dirname(__FILE__).'/xmlgooglemaps_gpxParser.php');
			require_once(dirname(__FILE__).'/xmlgooglemaps_googleChartsAPI.php');
			$gpxfile = new gpxParser();				
			$gpxfile->parse($file_resolved);		
			$gpxdata = $gpxfile->output;
			if (($params->gpxView == "all") || ($params->gpxView == "trk")) {
				$trkmax = $gpxdata["trk_count"];
				$x_ele = array();
				$y_ele = array();
				$dist_speed = array();	
				$time_speed = array();
				$ptcount = 0;
				$dist = 0;							
				for ($trkcount=0;$trkcount<$trkmax; $trkcount++) {
					$trkptmax=$gpxdata["trk".$trkcount]["trkpt_count"];				
					for ($trkptcount=0;$trkptcount<$trkptmax; $trkptcount++) {												
						$pt = $gpxdata["trk".$trkcount]["trkpt".$trkptcount];						
						if ($ptcount==0) {
							$lat1 = floatval($pt["LAT"]);
							$lon1 = floatval($pt["LON"]);
							$time1 = myFunctions::xmlDate2DateTime($pt["TIME"]); 
						}
						$lat2 = floatval($pt["LAT"]);
						$lon2 = floatval($pt["LON"]);
						$time2 = myFunctions::xmlDate2DateTime($pt["TIME"]);
						$tmp = myFunctions::distBetween2PointsKM($lat1,$lon1,$lat2,$lon2);								
						if (!is_nan($tmp)) { 
							$dist += $tmp;
							if (($tmp>0) && ($time2-$time1>0)) {
								$dist_speed[] = $tmp;
								$time_speed[] = $time2-$time1;
							}
							if ($params->measurement == "imperial") {
								$x_ele[] = $dist/1.609344;
								$y_ele[] = $pt["ELE"]/0.3048;																
							} else {
								$x_ele[] = $dist;
								$y_ele[] = $pt["ELE"];
							}
							$lat1 = $lat2;
							$lon1 = $lon2;	
							$time1 = $time2;												
						}
						$ptcount++;
					}
				}
				if ($dist>0) {
					if ($params->gpxElevationChart == "show") {
						$alt = new googleChartsApi_PMPro($x_ele,$y_ele);																		
						$altstring .= '<img style="text-align: '.$params->align.'; margin: 0px; padding: 0px; max-width: 100%;" src="'.$alt->getEleUrl($params->width, $params->gpxElevationChartHeight,$params->gpxElevationLineColor,$params->gpxElevationLineWidth, $params->measurement, $params->gpxElevationChartTitle, $params->gpxCheckpointInterval).'" /><br />';					
					}
					if ($params->gpxSpeedChart == "show") {
						$newdist=0;
						$newtime=0;
						$newtotaldist=0;
						$x_speed = array();	
						$y_speed = array();					
						for ($spi=0;$spi<count($dist_speed); $spi++) {
							$newdist += $dist_speed[$spi];
							$newtotaldist += $dist_speed[$spi];
							$newtime += $time_speed[$spi];							
							switch (strtolower($params->measurement.$params->speedscale)) {								
								case "imperiallevel2":
									$x_speed[] = $newtotaldist/1.609344;
									$y_speed[] = ($newdist/1.609344) / ($newtime/3600);
									break;
								case "imperiallevel1":
									$x_speed[] = $newtotaldist/1.609344;
									$y_speed[] = ($newdist/0.3048) / ($newtime);
									break;
								case "metriclevel1":
									$x_speed[] = $newtotaldist;
									$y_speed[] = ($newdist*1000) / ($newtime);
									break;
								default:
								case "metriclevel2":
									$x_speed[] = $newtotaldist;
									$y_speed[] = ($newdist) / ($newtime/3600);
									break;										
							}
							$newdist=0;
							$newtime=0;								
						}						
						$sp = new googleChartsApi_PMPro($x_speed, $y_speed, 0);																		
						$speedstring .= '<img style="text-align: '.$params->align.'; margin: 0px; padding: 0px; max-width: 100%;" src="'.$sp->getSpeedUrl($params->width, $params->gpxSpeedChartHeight,$params->gpxSpeedLineColor,$params->gpxSpeedLineWidth, $params->measurement, $params->speedscale, $params->gpxSpeedChartTitle, $params->gpxCheckpointInterval).'" /><br />';					
					}
					if ($params->gpxCheckpointTable == "show") {
						$cptabstring = $params->gpxCheckpointTableTemplate;
						$cptabstring = str_replace("%WIDTH%",$params->width,$cptabstring);
						if ($params->measurement=="metric") {
							$divident = 1;									
							$measurement = "km";
							if ($params->speedscale == "level1") {
								$scale = "m/s";
							} else {
								$scale = "km/s";								
							}
						} else {
							$divident = 1.609344;
							$measurement = "mi";
							if ($params->speedscale == "level1") {
								$scale = "fps";
							} else {
								$scale = "mph";								
							}							
						}				
						$trkmax = $gpxdata["trk_count"];
						$dist = 0;
						$totaltime = 0;
						$nextcheckpointnumber=1;
						$lastpt = "";
						$lastdist=0;
						$lasttotaltime=0;
						for ($trkcount=0;$trkcount<$trkmax; $trkcount++) {
							$trkptmax=$gpxdata["trk".$trkcount]["trkpt_count"];
							for ($trkptcount=0;$trkptcount<$trkptmax; $trkptcount+=$params->gpxInterval) {						
								$pt = $gpxdata["trk".$trkcount]["trkpt".$trkptcount];								
								if (($params->gpxCheckpointInterval>0)) {
									if (($trkcount > 0) || ($trkptcount>0)) {
										$totaltime += myFunctions::xmlDate2DateTime($pt["TIME"])-myFunctions::xmlDate2DateTime($lastpt["TIME"]);
										$dist += myFunctions::distBetween2PointsKM(floatval($lastpt["LAT"]),floatval($lastpt["LON"]),floatval($pt["LAT"]),floatval($pt["LON"]));
										if ($dist/$divident>$nextcheckpointnumber*$params->gpxCheckpointInterval) {
											
											$cpadd="";
											$cptabstringrow = $params->gpxCheckpointTableRowTemplate;
											$cptabstringrow = str_replace("%MARKERIMAGEURL%" , get_option('siteurl').'/wp-content/plugins/xml-google-maps/mm_20_'.$params->gpxCheckpointMarkerColor.$cpadd.'.png', $cptabstringrow);
											$cptabstringrow = str_replace("%DISTANCE%" , round($dist/$divident,3).' '.$measurement, $cptabstringrow);
											$cptabstringrow = str_replace("%PARTDISTANCE%" , round(($dist-$lastdist)/$divident,3).' '.$measurement, $cptabstringrow);
											$cptabstringrow = str_replace("%TIME%" , myFunctions::seconds2Text($totaltime), $cptabstringrow);
											$cptabstringrow = str_replace("%PARTTIME%" , myFunctions::seconds2Text($totaltime-$lasttotaltime), $cptabstringrow);
											$cptabstringrow = str_replace("%SPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$totaltime), $cptabstringrow);
											$cptabstringrow = str_replace("%PARTSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$totaltime-$lasttotaltime), $cptabstringrow);
											$cptabstring = str_replace("%ROW%",$cptabstringrow."%ROW%",$cptabstring);
																					
											$nextcheckpointnumber = floor(($dist/$divident) / $params->gpxCheckpointInterval) + 1;
											$lastdist=$dist;
											$lasttotaltime=$totaltime;		
										}
									} else {
										$cpadd="_s";
										$cptabstringrow = $params->gpxCheckpointTableRowTemplate;
										$cptabstringrow = str_replace("%MARKERIMAGEURL%" , get_option('siteurl').'/wp-content/plugins/xml-google-maps/mm_20_'.$params->gpxCheckpointMarkerColor.$cpadd.'.png', $cptabstringrow);
										$cptabstringrow = str_replace("%DISTANCE%" , round($dist/$divident,3).' '.$measurement, $cptabstringrow);
										$cptabstringrow = str_replace("%PARTDISTANCE%" , round(($dist-$lastdist)/$divident,3).' '.$measurement, $cptabstringrow);
										$cptabstringrow = str_replace("%TIME%" , myFunctions::seconds2Text($totaltime), $cptabstringrow);
										$cptabstringrow = str_replace("%PARTTIME%" , myFunctions::seconds2Text($totaltime-$lasttotaltime), $cptabstringrow);
										$cptabstringrow = str_replace("%SPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$totaltime), $cptabstringrow);
										$cptabstringrow = str_replace("%PARTSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$totaltime-$lasttotaltime), $cptabstringrow);
										$cptabstring = str_replace("%ROW%",$cptabstringrow."%ROW%",$cptabstring);										
									}
								}
								$lastpt = $pt;
							}											
						}
						if (($params->gpxCheckpointInterval>0)) {
							$cpadd="_e";
							$cptabstringrow = $params->gpxCheckpointTableRowTemplate;
							$cptabstringrow = str_replace("%MARKERIMAGEURL%" , get_option('siteurl').'/wp-content/plugins/xml-google-maps/mm_20_'.$params->gpxCheckpointMarkerColor.$cpadd.'.png', $cptabstringrow);
							$cptabstringrow = str_replace("%DISTANCE%" , round($dist/$divident,3).' '.$measurement, $cptabstringrow);
							$cptabstringrow = str_replace("%PARTDISTANCE%" , round(($dist-$lastdist)/$divident,3).' '.$measurement, $cptabstringrow);
							$cptabstringrow = str_replace("%TIME%" , myFunctions::seconds2Text($totaltime), $cptabstringrow);
							$cptabstringrow = str_replace("%PARTTIME%" , myFunctions::seconds2Text($totaltime-$lasttotaltime), $cptabstringrow);
							$cptabstringrow = str_replace("%SPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist,$totaltime), $cptabstringrow);
							$cptabstringrow = str_replace("%PARTSPEED%" , myFunctions::getSpeedString($params->measurement,$params->speedscale,$dist-$lastdist,$totaltime-$lasttotaltime), $cptabstringrow);							
							$cptabstring = str_replace("%ROW%",$cptabstringrow."%ROW%",$cptabstring);																	
						}	
						$cptabstring = $cptabstring = str_replace("%ROW%","",$cptabstring);;			
					}
				}
			}					
		}
		$repstring = '<div style="text-align: '.$params->align.';">';
		$repstring .= '<iframe src="'.get_option('siteurl').'/wp-content/plugins/xml-google-maps/xmlgooglemaps_show.php?gpxid='.$gpxid.'" style="border: 0px; width: '.$params->width.'px; height: '.$params->height.'px;" name="Google_Gpx_Maps" frameborder="0">';
		$repstring .= '</iframe></div>'.$altstring.$speedstring.$cptabstring.$displayurl.'';
		$content = str_replace($found[0][$i],$repstring,$content);
	}	
	return $content;
}

function gmxml_tableexists($tablename) {
	global $wpdb;
	foreach ($wpdb->get_col("SHOW TABLES",0) as $table ) {
		if ($table == $tablename) {
			return true;
		}
	}
	return false;
}

function gmxml_columnexists($tablename, $columnname) {
	global $wpdb;
	foreach ($wpdb->get_col("DESC $tablename", 0) as $column ) {
		if ($column == $columnname) {
			return true;
		}
	}
	return false;
}

function getid($path, $resolvedpath, $varstring) {
	global $wpdb;
	// Check IP From IP Logging Database
	$ret = $wpdb->get_var("SELECT xml_id FROM $wpdb->xmlgooglemapsdb WHERE xml_path = '$path' AND xml_path_resolved = '$resolvedpath' AND xml_varstring = '$varstring'");
	if ($ret == 0) {
		$wpdb->query("INSERT INTO $wpdb->xmlgooglemapsdb (xml_path, xml_path_resolved, xml_varstring) VALUES ('$path','$resolvedpath','$varstring')");
		$ret = getid($path, $resolvedpath, $varstring);
	}
	return intval($ret);	
}


//Optiona Page
function xmlgm_options_page() {
	global $wpdb;
	require_once(dirname(__FILE__).'/xmlgooglemaps_helper.php');
	// If we are a postback, store the options
 	if (isset($_POST['info_update'])) {
		check_admin_referer();
		
		// Google Maps API
		$xmlgm_uid = $_POST[key_xmlgm_uid];
		if ($xmlgm_uid == '')
			$xmlgm_uid = xmlgm_uid_default;
		update_option(key_xmlgm_uid, $xmlgm_uid);
		
		//Width
		$xmlgm_width = intval($_POST[key_xmlgm_width]);
		if ($xmlgm_width == 0)
			$xmlgm_width = xmlgm_width_default;
		update_option(key_xmlgm_width, $xmlgm_width);
		
		//Height
		$xmlgm_height = intval($_POST[key_xmlgm_height]);
		if ($xmlgm_height == 0)
			$xmlgm_height = xmlgm_height_default;
		update_option(key_xmlgm_height, $xmlgm_height);

		// IFrame Align
		$xmlgm_align = $_POST[key_xmlgm_align];
		if ($xmlgm_align == '')
			$xmlgm_align = xmlgm_align_default;
		update_option(key_xmlgm_align, $xmlgm_align);		

		// Line Color
		$xmlgm_linecolor = myFunctions::colorName2Hex($_POST[key_xmlgm_linecolor]);
		if ($xmlgm_linecolor == '')
			$xmlgm_linecolor = xmlgm_linecolor_default;
		update_option(key_xmlgm_linecolor, $xmlgm_linecolor);

		// Elevation Line Color
		$xmlgm_elelinecolor = myFunctions::colorName2Hex($_POST[key_xmlgm_elevlinecolor]);
		if ($xmlgm_elelinecolor == '')
			$xmlgm_elelinecolor = xmlgm_elevlinecolor_default;
		update_option(key_xmlgm_elevlinecolor, $xmlgm_elelinecolor);

		// Elevation Chart Visibility
		$xmlgm_elevationchart = $_POST[key_xmlgm_elevationchart];
		if ($xmlgm_elevationchart == '')
			$xmlgm_elevationchart = xmlgm_elevationchart_default;
		update_option(key_xmlgm_elevationchart, $xmlgm_elevationchart);
		
		//Elevation Line Width
		$xmlgm_elelinewidth = intval($_POST[key_xmlgm_elelinewidth]);
		if ($xmlgm_elelinewidth == 0)
			$xmlgm_elelinewidth = xmlgm_elelinewidth_default;
		update_option(key_xmlgm_elelinewidth, $xmlgm_elelinewidth);

		// Speed Line Color
		$xmlgm_speedlinecolor = myFunctions::colorName2Hex($_POST[key_xmlgm_speedlinecolor]);
		if ($xmlgm_speedlinecolor == '')
			$xmlgm_speedlinecolor = xmlgm_speedlinecolor_default;
		update_option(key_xmlgm_speedlinecolor, $xmlgm_speedlinecolor);

		// Speed Chart Visibility
		$xmlgm_speedchart = $_POST[key_xmlgm_speedchart];
		if ($xmlgm_speedchart == '')
			$xmlgm_speedchart = xmlgm_speedchart_default;
		update_option(key_xmlgm_speedchart, $xmlgm_speedchart);
		
		//Speed Line Width
		$xmlgm_speedlinewidth = intval($_POST[key_xmlgm_speedlinewidth]);
		if ($xmlgm_speedlinewidth == 0)
			$xmlgm_speedlinewidth = xmlgm_speedlinewidth_default;
		update_option(key_xmlgm_speedlinewidth, $xmlgm_speedlinewidth);				
				
		// URL Display Mode
		$xmlgm_urldisplaymode = $_POST[key_xmlgm_urldisplaymode];
		if ($xmlgm_urldisplaymode == '')
			$xmlgm_urldisplaymode = xmlgm_urldisplaymode_default;
		update_option(key_xmlgm_urldisplaymode, $xmlgm_urldisplaymode);

		//Map View Style
		$xmlgm_viewstyle = $_POST[key_xmlgm_viewstyle];
		if ($xmlgm_viewstyle == '')
			$xmlgm_viewstyle = xmlgm_viewstyle_default;
		update_option(key_xmlgm_viewstyle, $xmlgm_viewstyle);

		//Line Width
		$xmlgm_linewidth = intval($_POST[key_xmlgm_linewidth]);
		if ($xmlgm_linewidth == 0)
			$xmlgm_linewidth = xmlgm_linewidth_default;
		update_option(key_xmlgm_linewidth, $xmlgm_linewidth);		

		//Elevation Height
		$xmlgm_eleheight = intval($_POST[key_xmlgm_elevationheight]);
		if ($xmlgm_eleheight == 0)
			$xmlgm_eleheight = xmlgm_elevationheight_default;
		update_option(key_xmlgm_elevationheight, $xmlgm_eleheight);		

		//Elevation Height
		$xmlgm_speedheight = intval($_POST[key_xmlgm_speedheight]);
		if ($xmlgm_speedheight == 0)
			$xmlgm_speedheight = xmlgm_speedheight_default;
		update_option(key_xmlgm_speedheight, $xmlgm_speedheight);		
		
		//Line Opacity
		$xmlgm_lineopacity = intval($_POST[key_xmlgm_lineopacity]);
		if (($xmlgm_lineopacity < 0) || ($xmlgm_lineopacity > 100)) 
			$xmlgm_lineopacity = xmlgm_lineopacity_default;
		update_option(key_xmlgm_lineopacity, $xmlgm_lineopacity);

		//GPX View Style
		$xmlgm_gpxview = $_POST[key_xmlgm_gpxview];
		if ($xmlgm_gpxview == '')
			$xmlgm_gpxview = xmlgm_gpxview_default;
		update_option(key_xmlgm_gpxview, $xmlgm_gpxview);

		//Pan/Zoom Control
		$xmlgm_panzoomcontrol = $_POST[key_xmlgm_panzoomcontrol];
		if ($xmlgm_panzoomcontrol == '')
			$xmlgm_panzoomcontrol = xmlgm_panzoomcontrol_default;
		update_option(key_xmlgm_panzoomcontrol, $xmlgm_panzoomcontrol);

		//Overview Map Control
		$xmlgm_overviewmap = $_POST[key_xmlgm_overviewmap];
		if ($xmlgm_overviewmap == '')
			$xmlgm_overviewmap = xmlgm_overviewmap_default;
		update_option(key_xmlgm_overviewmap, $xmlgm_overviewmap);
		
		//Scale Control
		$xmlgm_scalecontrol = $_POST[key_xmlgm_scalecontrol];
		if ($xmlgm_scalecontrol == '')
			$xmlgm_scalecontrol = xmlgm_scalecontrol_default;
		update_option(key_xmlgm_scalecontrol, $xmlgm_scalecontrol);

		//Map Type Control
		$xmlgm_maptypecontrol = $_POST[key_xmlgm_maptypecontrol];
		if ($xmlgm_maptypecontrol == '')
			$xmlgm_maptypecontrol = xmlgm_maptypecontrol_default;
		update_option(key_xmlgm_maptypecontrol, $xmlgm_maptypecontrol);

		//Measurement Type
		$xmlgm_elevationmeasurement = $_POST[key_xmlgm_elevationmeasurement];
		if ($xmlgm_elevationmeasurement == '')
			$xmlgm_elevationmeasurement = xmlgm_elevationmeasurement_default;
		update_option(key_xmlgm_elevationmeasurement, $xmlgm_elevationmeasurement);
		
		//Speed Scale
		$xmlgm_speedscale = $_POST[key_xmlgm_speedscale];
		if ($xmlgm_speedscale == '')
			$xmlgm_speedscale = xmlgm_speedscale_default;
		update_option(key_xmlgm_speedscale, $xmlgm_speedscale);		

		//GPX Waypoint CSS Style
		$xmlgm_gpxcssstyle = $_POST[key_xmlgm_gpxcssstyle];
		if ($xmlgm_gpxcssstyle == '')
			$xmlgm_gpxcssstyle = xmlgm_gpxcssstyle_default;
		update_option(key_xmlgm_gpxcssstyle, $xmlgm_gpxcssstyle);
		
		//Map Button Normal
		$xmlgm_mapnorm = $_POST[key_xmlgm_mapnorm];
		if ($xmlgm_mapnorm == '')
			$xmlgm_mapnorm = xmlgm_mapnorm_default;
		update_option(key_xmlgm_mapnorm, $xmlgm_mapnorm);

		//Map Satellite Normal
		$xmlgm_mapsat = $_POST[key_xmlgm_mapsat];
		if ($xmlgm_mapsat == '')
			$xmlgm_mapsat = xmlgm_mapsat_default;
		update_option(key_xmlgm_mapsat, $xmlgm_mapsat);
		
		//Map Hybrid Normal
		$xmlgm_maphyb = $_POST[key_xmlgm_maphyb];
		if ($xmlgm_maphyb == '')
			$xmlgm_maphyb = xmlgm_maphyb_default;
		update_option(key_xmlgm_maphyb, $xmlgm_maphyb);
		
		//Map Physical Normal
		$xmlgm_mapphy = $_POST[key_xmlgm_mapphy];
		if ($xmlgm_mapphy == '')
			$xmlgm_mapphy = xmlgm_mapphy_default;
		update_option(key_xmlgm_mapphy, $xmlgm_mapphy);				

		//Map Google Earth  Plugin
		$xmlgm_mapearth = $_POST[key_xmlgm_mapearth];
		if ($xmlgm_mapearth == '')
			$xmlgm_mapearth = xmlgm_mapearth_default;
		update_option(key_xmlgm_mapearth, $xmlgm_mapearth);				
		
		//Dragging
		$xmlgm_dragging = $_POST[key_xmlgm_dragging];
		if ($xmlgm_dragging == '')
			$xmlgm_dragging = xmlgm_dragging_default;
		update_option(key_xmlgm_dragging, $xmlgm_dragging);				
		
		//Double Click Zoom
		$xmlgm_doubleclickzoom = $_POST[key_xmlgm_doubleClickZoom];
		if ($xmlgm_doubleclickzoom == '')
			$xmlgm_doubleclickzoom = xmlgm_doubleClickZoom_default;
		update_option(key_xmlgm_doubleClickZoom, $xmlgm_doubleclickzoom);				
		
		//Continuous Zoom
		$xmlgm_continuouszoom = $_POST[key_xmlgm_continuousZoom];
		if ($xmlgm_continuouszoom == '')
			$xmlgm_continuouszoom = xmlgm_continuousZoom_default;
		update_option(key_xmlgm_continuousZoom, $xmlgm_continuouszoom);				
		
		//Google Bar
		$xmlgm_googlebar = $_POST[key_xmlgm_googleBar];
		if ($xmlgm_googlebar == '')
			$xmlgm_googlebar = xmlgm_googleBar_default;
		update_option(key_xmlgm_googleBar, $xmlgm_googlebar);				
		
		//Scroll Wheel Zoom
		$xmlgm_scrollwheelzoom = $_POST[key_xmlgm_scrollWheelZoom];
		if ($xmlgm_scrollwheelzoom == '')
			$xmlgm_scrollwheelzoom = xmlgm_scrollWheelZoom_default;
		update_option(key_xmlgm_scrollWheelZoom, $xmlgm_scrollwheelzoom);				

		//Elevation Chart Title
		update_option(key_xmlgm_elevationtitle, $_POST[key_xmlgm_elevationtitle]);				

		//Speed Chart Title
		update_option(key_xmlgm_speedcharttitle, $_POST[key_xmlgm_speedcharttitle]);

		//Checkpoint Marker Color
		$xmlgm_cpcol = $_POST[key_xmlgm_checkpointmapmarkercolor];
		if ($xmlgm_cpcol == '')
			$xmlgm_cpcol = xmlgm_checkpointmapmarkercolor_default;
		update_option(key_xmlgm_checkpointmapmarkercolor, $xmlgm_cpcol);

		//Checkpoint Table
		$xmlgm_cptable = $_POST[key_xmlgm_checkpointtable];
		if ($xmlgm_cptable == '')
			$xmlgm_cptable = xmlgm_checkpointtable_default;
		update_option(key_xmlgm_checkpointtable, $xmlgm_cptable);

		//Checkpoint Interval
		$xmlgm_cpint = floatval($_POST[key_xmlgm_checkpointinterval]);
		update_option(key_xmlgm_checkpointinterval, $xmlgm_cpint);
		
		//Checkpoint Table Template
		$xmlgm_cptabletempl = $_POST[key_xmlgm_checkpointtabletempl];
		if ($xmlgm_cptabletempl == '') {
			$filename = dirname(__FILE__)."/defaultcptable.template";
			$handle = fopen ($filename, "r");
			$xmlgm_cptabletempl = fread ($handle, filesize ($filename));
			fclose ($handle);			
		} else {
			$xmlgm_cptabletempl = str_replace('\"','"',$xmlgm_cptabletempl);
			$xmlgm_cptabletempl = str_replace("\'","'",$xmlgm_cptabletempl);
		}
		update_option(key_xmlgm_checkpointtabletempl, $xmlgm_cptabletempl);
		
		//Checkpoint Table Row Template
		$xmlgm_cptablerowtempl = $_POST[key_xmlgm_checkpointtablerowtempl];
		if ($xmlgm_cptablerowtempl == '') {
			$filename = dirname(__FILE__)."/defaultcptablerow.template";
			$handle = fopen ($filename, "r");
			$xmlgm_cptablerowtempl = fread ($handle, filesize ($filename));
			fclose ($handle);			
		} else {
			$xmlgm_cptablerowtempl = str_replace('\"','"',$xmlgm_cptablerowtempl);
			$xmlgm_cptablerowtempl = str_replace("\'","'",$xmlgm_cptablerowtempl);
		}
		update_option(key_xmlgm_checkpointtablerowtempl, $xmlgm_cptablerowtempl);		
		
		// Give an updated message
		echo "<div class='updated'><p><strong>XML Google Maps options updated</strong></p></div>";
	} else {
		//Default Werte setzen
		if (strlen(get_option(key_xmlgm_checkpointtabletempl))==0) {
			$filename = dirname(__FILE__)."/defaultcptable.template";
			$handle = fopen ($filename, "r");
			$tmp = fread ($handle, filesize ($filename));
			fclose ($handle);			
			update_option(key_xmlgm_checkpointtabletempl, $tmp);
		}		
		if (strlen(get_option(key_xmlgm_checkpointtablerowtempl))==0) {
			$filename = dirname(__FILE__)."/defaultcptablerow.template";
			$handle = fopen ($filename, "r");
			$tmp = fread ($handle, filesize ($filename));
			fclose ($handle);			
			update_option(key_xmlgm_checkpointtablerowtempl, $tmp);
		}
	}
	$navigation .= '<td  rowspan="100%" width="15%" valign="top">';
	$navigation .= '<div style="text-align: right;"><p><b>Navigation:</b><br /><a href="#basic">Basic Options</a><br /><a href="#control">Control Options</a><br /><a href="#maptype">Map Type Options</a><br /><a href="#mapbehaviour">Map Behaviour Options</a><br /><a href="#gpx">GPX Options</a><br /><a href="#elev">Elevation Chart Options</a><br /><a href="#speedchart">Speed Chart Options</a><br /><a href="#checkpoint">Checkpoint Options</a></p></div>';
	$navigation .= '<div style="text-align: right;"><input class="button" type="submit" name="info_update" value="Save Changes" /></div>';
	$navigation .= '</td>';
	// Output the options page
	?>
		<script type="text/javascript">
		<!--
			var enabling = function() {
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_viewstyle; ?>.value=="G_NORMAL_MAP") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapnorm; ?>.value = "show";
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapnorm; ?>.disabled = true;
				} else {
				 	document.forms['xmlgmform'].<?php echo key_xmlgm_mapnorm; ?>.disabled = (document.forms['xmlgmform'].<?php echo key_xmlgm_maptypecontrol; ?>.value == "hide");
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_viewstyle; ?>.value=="G_HYBRID_MAP") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_maphyb; ?>.value = "show";
					document.forms['xmlgmform'].<?php echo key_xmlgm_maphyb; ?>.disabled = true;
				} else {
				 	document.forms['xmlgmform'].<?php echo key_xmlgm_maphyb; ?>.disabled = (document.forms['xmlgmform'].<?php echo key_xmlgm_maptypecontrol; ?>.value == "hide");
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_viewstyle; ?>.value=="G_PHYSICAL_MAP") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapphy; ?>.value = "show";
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapphy; ?>.disabled = true;
				} else {
				 	document.forms['xmlgmform'].<?php echo key_xmlgm_mapphy; ?>.disabled = (document.forms['xmlgmform'].<?php echo key_xmlgm_maptypecontrol; ?>.value == "hide");
				}
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_viewstyle; ?>.value=="G_SATELLITE_3D_MAP") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapearth; ?>.value = "show";
					document.forms['xmlgmform'].<?php echo key_xmlgm_mapearth; ?>.disabled = true;
				} else {
				 	document.forms['xmlgmform'].<?php echo key_xmlgm_mapearth; ?>.disabled = (document.forms['xmlgmform'].<?php echo key_xmlgm_maptypecontrol; ?>.value == "hide");
				}					
				if (document.forms['xmlgmform'].<?php echo key_xmlgm_elevationmeasurement; ?>.value == "imperial") {
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[0].text = "Foot per second (level1)"							 
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[1].text = "Miles per hour (level2)"
				} else {
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[0].text = "Metre per second (level1)"							 
					document.forms['xmlgmform'].<?php echo key_xmlgm_speedscale; ?>.options[1].text = "Kilometre per hour (level2)"				
				}
				
				document.forms['xmlgmform'].cpmarker.src = "<?php echo get_option('siteurl'); ?>/wp-content/plugins/xml-google-maps/mm_20_" + document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointmapmarkercolor; ?>.value + ".png";
				document.forms['xmlgmform'].cpmarker_start.src = "<?php echo get_option('siteurl'); ?>/wp-content/plugins/xml-google-maps/mm_20_" + document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointmapmarkercolor; ?>.value + "_s.png";
				document.forms['xmlgmform'].cpmarker_end.src = "<?php echo get_option('siteurl'); ?>/wp-content/plugins/xml-google-maps/mm_20_" + document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointmapmarkercolor; ?>.value + "_e.png";
				//Validation of Checkpoint Table Parameter
				var tmp = parseFloat(document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointinterval; ?>.value);
				if (tmp <= 0 || isNaN(tmp)) {
					document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointtable; ?>.value = "hide";
					document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointtable; ?>.disabled = true;
				} else {
					document.forms['xmlgmform'].<?php echo key_xmlgm_checkpointtable; ?>.disabled = false;
				}
			}
		//-->
		</script>
		<form method="post" name="xmlgmform" action="options-general.php?page=xmlgooglemaps.php">
		<div class="wrap">
			<h2>XML Google Maps Options</h2>
		
				<h3><a name="basic"></a>Basic Options</h3>
				<p>First of all you have to get your own Google API Key from the following page <a href="http://code.google.com/apis/maps/signup.html" target="_blank">http://code.google.com/apis/maps/signup.html</a>. Then specify the width, height and align of the google maps plugin in your posts.</p>    
				<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
					<tr>
						<th valign="top" style="padding-top: 10px;" width="35%">
							<label for="<?php echo key_xmlgm_uid; ?>">Your Google Maps API Key:</label>
						</th>
						<td width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_uid."' ";
							echo "id='".key_xmlgm_uid."' ";
							echo "value='".get_option(key_xmlgm_uid)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter your Google Maps API Key in this box. You get your Google Maps API Key from <a href="http://code.google.com/apis/maps/signup.html" target="_blank">http://code.google.com/apis/maps/signup.html</a>.</p>
						</td>
						<?php echo $navigation; ?>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;" width="35%">
							<label for="<?php echo key_xmlgm_width; ?>">Width:</label>
						</th>
						<td width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_width."' ";
							echo "id='".key_xmlgm_width."' ";
							echo "value='".get_option(key_xmlgm_width)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the width of your Map on your posts or pages (only numeric value allowed)</p>
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;" width="35%">
							<label for="<?php echo key_xmlgm_height; ?>">Height:</label>
						</th>
						<td width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_height."' ";
							echo "id='".key_xmlgm_height."' ";
							echo "value='".get_option(key_xmlgm_height)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the height of your Map on your posts or pages (only numeric values allowed)</p>
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_align; ?>">Google Map alignement:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_align."' ";
							echo "id='".key_xmlgm_align."'>";
							switch (get_option(key_xmlgm_align)) 
							{
								case "right": $selright = "selected='selected'"; break;
								case "center": $selcenter = "selected='selected'"; break;
								default: $selleft = "selected='selected'"; break;
							}
							echo "<option value='left' $selleft>Left (left)</option>";
							echo "<option value='center' $selcenter>Center (center)</option>";
							echo "<option value='right' $selright>Right (right)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Specifies the alignement of the map in your posts or pages</p>
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_urldisplaymode; ?>">URL Display Mode:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_urldisplaymode."' ";
							echo "id='".key_xmlgm_urldisplaymode."'>";
							switch (get_option(key_xmlgm_urldisplaymode)) 
							{
								case "none": $selnoneud = "selected='selected'"; break;
								case "showvars": $selvars = "selected='selected'"; break;
								default: $seldefault = "selected='selected'"; break;
							}
							echo "<option value='title' $seldefault>Map, URL Title without Parameters (title)</option>";
							echo "<option value='none' $selnoneud>Map only (none)</option>";
							echo "<option value='showvars' $selvars>Map, URL Title and Parameters (showvars)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Specifies how to tranform the added Link. If you want to completely remove it then select &apos;Map only&apos;. If you want to remove only the parameters, then select &apos;Map, URL Title without Parameters&apos;. Orelse if you want to show the whole link as you typed it in then select &apos;Map, URL Title and Parameters&apos;.</p>
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_elevationmeasurement; ?>">Measurement Type:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select onchange='enabling();' ";
							echo "name='".key_xmlgm_elevationmeasurement."' ";
							echo "id='".key_xmlgm_elevationmeasurement."'>";
							switch (get_option(key_xmlgm_elevationmeasurement)) 
							{
								case "imperial": $selelemimp = "selected='selected'"; break;
								default: $selelemmet = "selected='selected'"; break;
							}
							echo "<option value='imperial' $selelemimp>Miles / Feet (imperial)</option>";
							echo "<option value='metric' $selelemmet>Kilometres / Metres (metric)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Measurement Type</p>
						</td>
					</tr>						
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_speedscale; ?>">Speed Scale:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select onchange='enabling();' ";
							echo "name='".key_xmlgm_speedscale."' ";
							echo "id='".key_xmlgm_speedscale."'>";
							switch (get_option(key_xmlgm_speedscale)) 
							{
								case "level1": $selspeedl1 = "selected='selected'"; break;
								default: $selspeedl2 = "selected='selected'"; break;
							}							
							echo "<option value='level1' $selspeedl1>Level 1 (level2)</option>";
							echo "<option value='level2' $selspeedl2>Level 2 (level1)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Speed Scale</p>
						</td>
					</tr>																								
				</table>						
				<h3><a name="control"></a>Control Options</h3>
				<p>Define the controls you want to display on your map</p>
				<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_panzoomcontrol; ?>">Pan/Zoom Control:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_panzoomcontrol."' ";
							echo "id='".key_xmlgm_panzoomcontrol."'>";
							switch (get_option(key_xmlgm_panzoomcontrol)) 
							{
								case "hide": $selnonepz = "selected='selected'"; break;
								case "small": $selsmall = "selected='selected'"; break;
								case "zoom": $selzoom = "selected='selected'"; break;
								default: $sellarge = "selected='selected'"; break;
							}
							echo "<option value='hide' $selnonepz>Invisible (hide)</option>";
							echo "<option value='large' $sellarge>Large (large)</option>";
							echo "<option value='small' $selsmall>Small (small)</option>";
							echo "<option value='zoom' $selzoom>Zoom only (zoom)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Specifies the display style of the Pan/Zoom Control</p>
						</td>
						<?php echo $navigation; ?>
					</tr>									
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_overviewmap; ?>">Overview Map Control:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_overviewmap."' ";
							echo "id='".key_xmlgm_overviewmap."'>";
							switch (get_option(key_xmlgm_overviewmap)) 
							{
								case "show": $selshowom = "selected='selected'"; break;
								default: $selhideom = "selected='selected'"; break;
							}
							echo "<option value='hide' $selhideom>Invisible (hide)</option>";
							echo "<option value='show' $selshowom>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Shows/Hides the overview map in the bottom right corner</p>
						</td>
					</tr>									
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_scalecontrol; ?>">Scale Control:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_scalecontrol."' ";
							echo "id='".key_xmlgm_scalecontrol."'>";
							switch (get_option(key_xmlgm_scalecontrol)) 
							{
								case "show": $selshowsc = "selected='selected'"; break;
								default: $selhidesc = "selected='selected'"; break;
							}
							echo "<option value='hide' $selhidesc>Invisible (hide)</option>";
							echo "<option value='show' $selshowsc>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Shows/Hides the scale ruler in the bottom left corner</p>
						</td>
					</tr>	
				</table>
				<h3><a name="maptype"></a>Map Type Options</h3>
				<p>This optionset helps you to define all Map Type Option. Even the Map Type Control options you can change.</p> 
				<table class="form-table" cellspacing="2" cellpadding="5" width="100%">				
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_viewstyle; ?>">Default Map Type:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select onchange='enabling();' ";
							echo "name='".key_xmlgm_viewstyle."' ";
							echo "id='".key_xmlgm_viewstyle."'>";
							switch (get_option(key_xmlgm_viewstyle)) 
							{
								case "G_SATELLITE_TYPE":
								case "G_SATELLITE_MAP": 
									$selsat = "selected='selected'"; break;
								case "G_HYBRID_TYPE":
								case "G_HYBRID_MAP":  
									$selhyb = "selected='selected'"; break;
								case "G_PHYSICAL_TYPE": 
								case "G_PHYSICAL_MAP":
									$selphy = "selected='selected'"; break;
								case "G_SATELLITE_3D_TYPE": 
								case "G_SATELLITE_3D_MAP":
									$selearth = "selected='selected'"; break;
								default: 
									$selmap = "selected='selected'"; break;
							}
							echo "<option value='G_HYBRID_MAP' $selhyb>Hybrid (G_HYBRID_MAP)</option>";
							echo "<option value='G_SATELLITE_MAP' $selsat>Satellite (G_SATELLITE_MAP)</option>";
							echo "<option value='G_NORMAL_MAP' $selmap>Map (G_NORMAL_MAP)</option>";
							echo "<option value='G_PHYSICAL_MAP' $selphy>Physical (G_PHYSICAL_MAP)</option>";
							echo "<option value='G_SATELLITE_3D_MAP' $selearth>Google Earth Plugin (G_SATELLITE_3D_MAP)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Default Map Display Style</p>
						</td>
						<?php echo $navigation; ?>
					</tr>																			
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_maptypecontrol; ?>">Map Type Control:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select onchange='enabling();'";
							echo "name='".key_xmlgm_maptypecontrol."' ";
							echo "id='".key_xmlgm_maptypecontrol."'>";
							switch (get_option(key_xmlgm_maptypecontrol)) 
							{
								case "hide": $selhidemtc = "selected='selected'"; break;
								case "hierarchical": $selhidemhier = "selected='selected'"; break;
								default: $selshowmtc = "selected='selected'"; break;
							}
							echo "<option value='hide' $selhidemtc>Invisible (hide)</option>";
							echo "<option value='show' $selshowmtc>Visible Default (show)</option>";
							echo "<option value='hierarchical' $selhidemhier>Visible Hierarchical Control (hierarchical)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Show/Hide Map Type Control</p>
						</td>						
					</tr>						
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_mapnorm; ?>">Normal Map Type Button:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_mapnorm."' ";
							echo "id='".key_xmlgm_mapnorm."'>";
							switch (get_option(key_xmlgm_mapnorm)) 
							{
								case "hide": $selhidemapnorm = "selected='selected'"; break;
								default: $selshowmapnorm = "selected='selected'"; break;
							}
							echo "<option value='hide' $selhidemapnorm>Invisible (hide)</option>";
							echo "<option value='show' $selshowmapnorm>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Show/Hide Normal Map Type Button</p>
						</td>
					</tr>		
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_mapsat; ?>">Satellite Map Type Button:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_mapsat."' ";
							echo "id='".key_xmlgm_mapsat."'>";
							switch (get_option(key_xmlgm_mapsat)) 
							{
								case "hide": $selhidemapsat = "selected='selected'"; break;
								default: $selshowmapsat = "selected='selected'"; break;
							}
							echo "<option value='hide' $selhidemapsat>Invisible (hide)</option>";
							echo "<option value='show' $selshowmapsat>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Show/Hide Satellite Map Type Button</p>
						</td>
					</tr>														
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_maphyb; ?>">Hybrid Map Type Button:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_maphyb."' ";
							echo "id='".key_xmlgm_maphyb."'>";
							switch (get_option(key_xmlgm_maphyb)) 
							{
								case "hide": $selhidemaphyb = "selected='selected'"; break;
								default: $selshowmaphyb = "selected='selected'"; break;
							}
							echo "<option value='hide' $selhidemaphyb>Invisible (hide)</option>";
							echo "<option value='show' $selshowmaphyb>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Show/Hide Hybrid Map Type Button</p>
						</td>
					</tr>														
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_mapphy; ?>">Physical Map Type Button:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_mapphy."' ";
							echo "id='".key_xmlgm_mapphy."'>";
							switch (get_option(key_xmlgm_mapphy)) 
							{
								case "hide": $selhidemapphy = "selected='selected'"; break;
								default: $selshowmapphy = "selected='selected'"; break;
							}
							echo "<option value='hide' $selhidemapphy>Invisible (hide)</option>";
							echo "<option value='show' $selshowmapphy>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Show/Hide Physical Map Type Button</p>
						</td>
					</tr>																															
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_mapearth; ?>">Google Earth Plugin Map Type Button:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_mapearth."' ";
							echo "id='".key_xmlgm_mapearth."'>";
							switch (get_option(key_xmlgm_mapearth)) 
							{
								case "hide": $selhidemapearth = "selected='selected'"; break;
								default: $selshowmapearth = "selected='selected'"; break;
							}
							echo "<option value='hide' $selhidemapearth>Invisible (hide)</option>";
							echo "<option value='show' $selshowmapearth>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Show/Hide Google Earth Plugin Map Type Button</p>
						</td>
					</tr>																															
				</table>
				<h3><a name="mapbehaviour"></a>Map Behaviour Options</h3>
				<p>Customize the behaviour of the map (e.g. zoom behaviours).</p>    
				<table class="form-table" cellspacing="2" cellpadding="5" width="100%">
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_dragging; ?>">Dragging:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_dragging."' ";
							echo "id='".key_xmlgm_dragging."'>";
							switch (get_option(key_xmlgm_dragging)) 
							{
								case "disabled": $seldraggingdis = "selected='selected'"; break;
								default: $seldraggingen = "selected='selected'"; break;
							}
							echo "<option value='disabled' $seldraggingdis>Disabled (disabled)</option>";
							echo "<option value='enabled' $seldraggingen>Enabled (enabled)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Enables/Disables the dragging of the map</p>
						</td>
						<?php echo $navigation; ?>
					</tr>																															
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_doubleClickZoom; ?>">Double Click Zoom:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_doubleClickZoom."' ";
							echo "id='".key_xmlgm_doubleClickZoom."'>";
							switch (get_option(key_xmlgm_doubleClickZoom)) 
							{
								case "disabled": $seldczdis = "selected='selected'"; break;
								default: $seldczen = "selected='selected'"; break;
							}
							echo "<option value='disabled' $seldczdis>Disabled (disabled)</option>";
							echo "<option value='enabled' $seldczen>Enabled (enabled)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Enables/Disables double click to zoom in and out</p>
						</td>
					</tr>																															
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_continuousZoom; ?>">Continuous Zoom:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_continuousZoom."' ";
							echo "id='".key_xmlgm_continuousZoom."'>";
							switch (get_option(key_xmlgm_continuousZoom)) 
							{
								case "disabled": $selczdis = "selected='selected'"; break;
								default: $selczen = "selected='selected'"; break;
							}
							echo "<option value='disabled' $selczdis>Disabled (disabled)</option>";
							echo "<option value='enabled' $selczen>Enabled (enabled)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Enables/Disables continuous smooth zooming for select browsers</p>
						</td>
					</tr>																															
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_scrollWheelZoom; ?>">Scroll Wheel Zoom:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_scrollWheelZoom."' ";
							echo "id='".key_xmlgm_scrollWheelZoom."'>";
							switch (get_option(key_xmlgm_scrollWheelZoom)) 
							{
								case "disabled": $selswzdis = "selected='selected'"; break;
								default: $selswzen = "selected='selected'"; break;
							}
							echo "<option value='disabled' $selswzdis>Disabled (disabled)</option>";
							echo "<option value='enabled' $selswzen>Enabled (enabled)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Enables/Disables zooming using a mouse's scroll wheel</p>
						</td>
					</tr>																															
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_googleBar; ?>">Google Bar:</label>
						</th>					
						<td width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_googleBar."' ";
							echo "id='".key_xmlgm_googleBar."'>";
							switch (get_option(key_xmlgm_googleBar)) 
							{
								case "enabled": $selgben = "selected='selected'"; break;
								default: $selgbdis = "selected='selected'"; break;
							}
							echo "<option value='disabled' $selgbdis>Disabled (disabled)</option>";
							echo "<option value='enabled' $selgben>Enabled (enabled)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Enables/Disables he GoogleBar, an integrated search control, to the map. When enabled, this control takes the place of the default Powered By Google logo.</p>
						</td>
					</tr>																															
				</table>
				<h3><a name="gpx"></a>GPX Options</h3>
				<p>Settings specific for GPX Files</p>
				<table class="form-table" cellspacing="2" cellpadding="5" width="100%">									
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_linecolor; ?>">Line Color:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_linecolor."' ";
							echo "id='".key_xmlgm_linecolor."' ";
							echo "value='".get_option(key_xmlgm_linecolor)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the default line color of any Track or Route</p>
						</td>
						<?php echo $navigation; ?>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;" width="35%">
							<label for="<?php echo key_xmlgm_linewidth; ?>">Line Width:</label>
						</th>
						<td width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_linewidth."' ";
							echo "id='".key_xmlgm_linewidth."' ";
							echo "value='".get_option(key_xmlgm_linewidth)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the default line width of any Track or Route</p>
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;" width="35%">
							<label for="<?php echo key_xmlgm_lineopacity; ?>">Line Opacity:</label>
						</th>
						<td width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_lineopacity."' ";
							echo "id='".key_xmlgm_lineopacity."' ";
							echo "value='".get_option(key_xmlgm_lineopacity)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the default line opacity (1-100) of any Track or Route</p>
						</td>
					</tr>	
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_gpxview; ?>">GPX View Style:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_gpxview."' ";
							echo "id='".key_xmlgm_gpxview."'>";
							switch (get_option(key_xmlgm_gpxview)) 
							{
								case "wpt": $selwpt = "selected='selected'"; break;
								case "rte": $selrte = "selected='selected'"; break;
								case "trk": $seltrk = "selected='selected'"; break;
								default: $selall = "selected='selected'"; break;
							}
							echo "<option value='all' $selall>Everything (all)</option>";
							echo "<option value='wpt' $selwpt>Waypoints (wpt)</option>";
							echo "<option value='rte' $selrte>Routes (rte)</option>";
							echo "<option value='trk' $seltrk>Tracks (trk)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Shows only the selected part of the GPX File.</p>
						</td>
					</tr>	
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_gpxcssstyle; ?>">Waypoint CSS Style:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_gpxcssstyle."' ";
							echo "id='".key_xmlgm_gpxcssstyle."' ";
							echo "value='".get_option(key_xmlgm_gpxcssstyle)."' />\n";
							?>
							<p style="margin: 5px 10px;">Define the GPX Waypoints Info Window CSS Style</p>
						</td>
					</tr>																												
				</table>
				<h3><a name="elev"></a>Elevation Chart Options</h3>
				<p>Settings for the Elevation Chart (now supported by GPX Tracks only)</p>
				<table class="form-table" cellspacing="2" cellpadding="5" width="100%">														
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_elevationchart; ?>">Elevation Chart:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_elevationchart."' ";
							echo "id='".key_xmlgm_elevationchart."'>";
							switch (get_option(key_xmlgm_elevationchart)) 
							{
								case "hide": $selelevhide = "selected='selected'"; break;
								default: $selelevshow = "selected='selected'"; break;
							}
							echo "<option value='hide' $selelevhide>Invisible (hide)</option>";
							echo "<option value='show' $selelevshow>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Visibility of evelation chart for GPX tracks</p>
						</td>
						<?php echo $navigation; ?>
					</tr>	
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_elevationtitle; ?>">Elevation Chart Title:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_elevationtitle."' ";
							echo "id='".key_xmlgm_elevationtitle."' ";
							echo "value='".get_option(key_xmlgm_elevationtitle)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the Elevation Chart Title (<b>do not use special chars</b>)</p>
						</td>
					</tr>									
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_elevationheight; ?>">Elevation Chart Height:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_elevationheight."' ";
							echo "id='".key_xmlgm_elevationheight."' ";
							echo "value='".get_option(key_xmlgm_elevationheight)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the height of the elevation chart!</p>
						</td>
					</tr>																		
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_elevlinecolor; ?>">Elevation Chart Line Color:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_elevlinecolor."' ";
							echo "id='".key_xmlgm_elevlinecolor."' ";
							echo "value='".get_option(key_xmlgm_elevlinecolor)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the default line color of the elevation charts line!</p>
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;" width="35%">
							<label for="<?php echo key_xmlgm_elelinewidth; ?>">Elevation Chart Line Width:</label>
						</th>
						<td width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_elelinewidth."' ";
							echo "id='".key_xmlgm_elelinewidth."' ";
							echo "value='".get_option(key_xmlgm_elelinewidth)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the default line width of the elevation chart</p>
						</td>
					</tr>
				</table>
				<h3><a name="speedchart"></a>Speed Chart Options</h3>
				<p>Settings for the Speed Chart (now supported by GPX Tracks only)</p>
				<table class="form-table" cellspacing="2" cellpadding="5" width="100%">														
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_speedchart; ?>">Speed Chart:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_speedchart."' ";
							echo "id='".key_xmlgm_speedchart."'>";
							switch (get_option(key_xmlgm_speedchart)) 
							{
								case "show": $selspeedshow = "selected='selected'"; break;
								default:  $selspeedhide = "selected='selected'"; break;
							}
							echo "<option value='hide' $selspeedhide>Invisible (hide)</option>";
							echo "<option value='show' $selspeedshow>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Visibility of speed chart for GPX tracks</p>
						</td>
						<?php echo $navigation; ?>
					</tr>	
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_speedcharttitle; ?>">Speed Chart Title:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_speedcharttitle."' ";
							echo "id='".key_xmlgm_speedcharttitle."' ";
							echo "value='".get_option(key_xmlgm_speedcharttitle)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the Speed Chart Title (<b>do not use special chars</b>)</p>
						</td>
					</tr>										
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_speedheight; ?>">Speed Chart Height:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_speedheight."' ";
							echo "id='".key_xmlgm_speedheight."' ";
							echo "value='".get_option(key_xmlgm_speedheight)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the height of the speed chart!</p>
						</td>
					</tr>																		
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_speedlinecolor; ?>">Speed Chart Line Color:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_speedlinecolor."' ";
							echo "id='".key_xmlgm_speedlinecolor."' ";
							echo "value='".get_option(key_xmlgm_speedlinecolor)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the default line color of the speed charts line!</p>
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;" width="35%">
							<label for="<?php echo key_xmlgm_speedlinewidth; ?>">Speed Chart Line Width:</label>
						</th>
						<td width="50%">
							<?php
							echo "<input type='text' size='50' ";
							echo "name='".key_xmlgm_speedlinewidth."' ";
							echo "id='".key_xmlgm_speedlinewidth."' ";
							echo "value='".get_option(key_xmlgm_speedlinewidth)."' />\n";
							?>
							<p style="margin: 5px 10px;">Enter the default line width of the speed chart</p>
						</td>
					</tr>
				</table>	
				<h3><a name="checkpoint"></a>Checkpoint Options</h3>
				<p>Settings for the Checkpoints (now supported by GPX Tracks only). To activate the checkpoint you have to set the gpxcheckpointinterval-Parameter on every map. The gpxcheckpointinterval-parameter defines the interval in km or mi between every checkpoint!</p>
				<table class="form-table" cellspacing="2" cellpadding="5" width="100%">														

					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_checkpointmapmarkercolor; ?>">Checkpoint Map Marker Color:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select onchange='enabling();' ";
							echo "name='".key_xmlgm_checkpointmapmarkercolor."' ";
							echo "id='".key_xmlgm_checkpointmapmarkercolor."'>";
							switch (get_option(key_xmlgm_checkpointmapmarkercolor)) 
							{
								case "red": $selcpmred = "selected='selected'"; break;
								case "green": $selcpmgreen = "selected='selected'"; break;
								case "yellow": $selcpmyellow = "selected='selected'"; break;
								case "blue": $selcpmblue = "selected='selected'"; break;
								default: $selcpmred = "selected='selected'"; break;
							}
							echo "<option value='red' $selcpmred>Red (red)</option>";
							echo "<option value='green' $selcpmgreen>Green (green)</option>";
							echo "<option value='yellow' $selcpmyellow>Yellow (yellow)</option>";
							echo "<option value='blue' $selcpmblue>Blue (blue)</option>";
							echo "</select>\n";
							?>
							<img id="cpmarker" name="cpmarker" src="" /> 							
							<img id="cpmarker_start" name="cpmarker_start" src="" />
							<img id="cpmarker_end" name="cpmarker_end" src="" />
							<p style="margin: 5px 10px;">Define the Marker Color for the Checkpoint</p>
						</td>
						<?php echo $navigation; ?>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_checkpointinterval; ?>">Checkpoint Interval:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<input type='text' size='50' onchange='enabling();'";
							echo "name='".key_xmlgm_checkpointinterval."' ";
							echo "id='".key_xmlgm_checkpointinterval."' ";
							echo "value='".get_option(key_xmlgm_checkpointinterval)."' />\n";
							?>
							<p style="margin: 5px 10px;">Set the checkpoint interval (0=disabled)!</p>
						</td>
					</tr>						
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_checkpointtable; ?>">Checkpoint Table:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<select ";
							echo "name='".key_xmlgm_checkpointtable."' ";
							echo "id='".key_xmlgm_checkpointtable."'>";
							switch (get_option(key_xmlgm_checkpointtable)) 
							{
								case "show": $selcptabshow = "selected='selected'"; break;
								default: $selcptabhide = "selected='selected'"; break;
							}
							echo "<option value='hide' $selcptabhide>Invisible (hide)</option>";
							echo "<option value='show' $selcptabshow>Visible (show)</option>";
							echo "</select>\n";
							?>
							<p style="margin: 5px 10px;">Visibility of checkpoint table (checkpointinterval has to be set to a value &gt;0)</p>
						</td>
					</tr>
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_checkpointtabletempl; ?>">Checkpoint Table Template:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<textarea rows='15' cols='50' style='width: 100%;'";
							echo "name='".key_xmlgm_checkpointtabletempl."' ";
							echo "id='".key_xmlgm_checkpointtabletempl."'>";
							echo get_option(key_xmlgm_checkpointtabletempl)."</textarea>\n";
							?>
							<p style="margin: 5px 10px;">Define your own table template. Use the following parameters for placeholders:<br/>
							%WIDTH% - Placeholder of the Width setting<br />
							%ROW% - Row Template Placeholder<br/><br/>
							Delete the whole content to restore the default value!</p>							
						</td>
					</tr>	
					<tr>
						<th valign="top" style="padding-top: 10px;"  width="35%">
							<label for="<?php echo key_xmlgm_checkpointtablerowtempl; ?>">Checkpoint Table Row Template:</label>
						</th>
						<td  width="50%">
							<?php
							echo "<textarea rows='15' cols='50' style='width: 100%;'";
							echo "name='".key_xmlgm_checkpointtablerowtempl."' ";
							echo "id='".key_xmlgm_checkpointtablerowtempl."'>";
							echo get_option(key_xmlgm_checkpointtablerowtempl)."</textarea>\n";
							?>
							<p style="margin: 5px 10px;">Define your own row template. Use the following parameters for placeholders:<br/>
								%MARKERIMAGEURL% - URL to the checkpoint Image <br />
								%PARTDISTANCE% - Distance between last and current Checkpoint<br />
								%PARTTIME% - Timedifference between the last and the current Checkpoint<br />
								%PARTSPEED% - Average speed between the last and the current Checkpoint<br />
								%DISTANCE% - Distance from start point<br />
								%TIME% - Time from the start point<br />
								%SPEED% - Speed from the start point<br/><br/>
								Delete the whole content to restore the default value!
							</p>
					</tr>																																																		
				</table>		
		</div>
		</form>
		<script type="text/javascript">
		<!--
			enabling();
		-->
		</script>		
<?php
}

function getDisplayURL($urldisplaymode, $displayurl, $varstring) {
	switch ($urldisplaymode) {
		case "none":
			$displayurl = "";
			break;
		case "showvars":
			$displayurl = $displayurl;
			break;
		default:
			$displayurl = str_replace("[".$varstring."]","",$displayurl);
			break;			
	}	
	return $displayurl;
}

// Not exististing Functions
if(!function_exists("stripos")) 
{
  function stripos($str, $needle) 
  {
   return strpos(strtolower($str),strtolower($needle));
  }
}

?>