<?php

class xml_gm_params {

	function xml_gm_params() {
		$this->width = intval(get_option(key_xmlgm_width));
		$this->height = intval(get_option(key_xmlgm_height));
		$this->align = intval(get_option(key_xmlgm_align));
		$this->googleMapsAPIKey = get_option(key_xmlgm_uid);
		$this->viewStyle = get_option(key_xmlgm_viewstyle);
		$this->urlDisplayMode = get_option(key_xmlgm_urldisplaymode);
		$this->panZoomControl = get_option(key_xmlgm_panzoomcontrol);
		$this->overViewMapControl = get_option(key_xmlgm_overviewmap);
		$this->scaleControl = get_option(key_xmlgm_scalecontrol);
		$this->mapTypeControl = get_option(key_xmlgm_maptypecontrol);
		$this->mapNormal = get_option(key_xmlgm_mapnorm);
		$this->mapHybrid = get_option(key_xmlgm_maphyb);
		$this->mapSatellite = get_option(key_xmlgm_mapsat);
		$this->mapPhysical = get_option(key_xmlgm_mapphy);
		$this->dragging = get_option(key_xmlgm_dragging);
		$this->doubleClickZoom = get_option(key_xmlgm_doubleClickZoom);
		$this->continuousZoom = get_option(key_xmlgm_continuousZoom);
		$this->googleBar = get_option(key_xmlgm_googleBar);
		$this->scrollWheelZoom = get_option(key_xmlgm_scrollWheelZoom);
		$this->measurement = get_option(key_xmlgm_elevationmeasurement);
		$this->speedscale = get_option(key_xmlgm_speedscale);
			
		$this->gpxLineColor = get_option(key_xmlgm_linecolor);
		$this->gpxLineWidth = intval(get_option(key_xmlgm_linewidth));
		$this->gpxLineOpacity = intval(get_option(key_xmlgm_lineopacity));
		$this->gpxView = get_option(key_xmlgm_gpxview);
		$this->gpxElevationLineColor = str_replace("#","",get_option(key_xmlgm_elevlinecolor));
		$this->gpxElevationChart = get_option(key_xmlgm_elevationchart);
		$this->gpxElevationLineWidth = intval(get_option(key_xmlgm_elelinewidth));
		$this->gpxElevationChartHeight = intval(get_option(key_xmlgm_elevationheight));
			
		$this->gpxElevationChartTitle = get_option(key_xmlgm_elevationtitle);
		$this->gpxSpeedLineColor = str_replace("#","",get_option(key_xmlgm_speedlinecolor));
		$this->gpxSpeedChart = get_option(key_xmlgm_speedchart);
		$this->gpxSpeedLineWidth = intval(get_option(key_xmlgm_speedlinewidth));
		$this->gpxSpeedChartHeight = intval(get_option(key_xmlgm_speedheight));
		$this->gpxSpeedChartTitle = get_option(key_xmlgm_speedcharttitle);
		$this->gpxCSSStyle = get_option(key_xmlgm_gpxcssstyle);
		$this->gpxCheckpointMarkerColor = get_option(key_xmlgm_checkpointmapmarkercolor);
		$this->gpxCheckpointInterval = get_option(key_xmlgm_checkpointinterval);
		$this->gpxCheckpointTable = get_option(key_xmlgm_checkpointtable);
		$this->gpxCheckpointTableTemplate = get_option(key_xmlgm_checkpointtabletemplate);
		$this->gpxCheckpointTableRowTemplate = get_option(key_xmlgm_checkpointtablerowtemplate);
		
		if (strlen($this->gpxCheckpointTableTemplate)==0) {
			$filename = dirname(__FILE__)."/defaultcptable.template";
			$handle = fopen ($filename, "r");
			$this->gpxCheckpointTableTemplate = fread ($handle, filesize ($filename));
			fclose ($handle);			
		}
		if (strlen($this->gpxCheckpointTableRowTemplate)==0) {
			$filename = dirname(__FILE__)."/defaultcptablerow.template";
			$handle = fopen ($filename, "r");
			$this->gpxCheckpointTableRowTemplate = fread ($handle, filesize ($filename));
			fclose ($handle);			
		}
		
	}

	var $width = 664;
	var $height = 400;
	var $align = "left";
	var $googleMapsAPIKey = "";
	var $viewStyle = "G_NORMAL_MAP";
	var $urlDisplayMode = "title";
	var $panZoomControl = "large";
	var $overViewMapControl = "hide";
	var $scaleControl = "hide";
	var $mapTypeControl = "show";
	var $mapNormal = "show";
	var $mapHybrid = "show";
	var $mapSatellite = "show";
	var $mapPhysical = "hide";
	var $mapEarth = "hide";
	var $dragging = "enabled";
	var $doubleClickZoom = "enabled";
	var $continuousZoom = "enabled";
	var $googleBar = "disabled";
	var $scrollWheelZoom = "enabled";

	var $manualZoom = 0;
	var $minLat = 0;
	var $maxLat = 0;
	var $minLon = 0;
	var $maxLon = 0;
	var $zoom = 0;
	var $deltazoom = 0;

	var $gpxLineColor = "#0000FF";
	var $gpxLineWidth = 5;
	var $gpxLineOpacity = 50;
	var $gpxView = "all";
	var $gpxInterval = 1;
	var $gpxElevationLineColor = "0000FF";
	var $gpxElevationLineWidth = 5;
	var $gpxElevationChart = "show";
	var $gpxElevationChartHeight = 200;
	var $measurement = "metric";
	var $speedscale = "level2";
	var $gpxSpeedLineColor = "0000FF";
	var $gpxSpeedLineWidth = 5;
	var $gpxSpeedChart = "hide";
	var $gpxSpeedChartHeight = 200;
	var $gpxCSSStyle = "font-family: Verdana, Arial, Sans-Serif;";
	var $gpxSpeedChartTitle = "Speed Profile";
	var $gpxElevationChartTitle = "Elevation Profile";
	var $gpxCheckpointInterval = 0;
	var $gpxCheckpointMarkerColor = "red";
	var $gpxCheckpointTable = "hide";	

	function printObjectHTMLComment() {
		print_r("<!-- Debug Info Actual Parameter Object \n");
		print_r($this);
		print_r("\n -->");
	}
		
	function setParams($param_string) {
		$manualzoom = 0;
		$vars = split(";",$param_string);
		for ($i=0 ;$i<count($vars);$i++) {
			$varvalue=split("=",$vars[$i]);
			if (count($varvalue)==2) {
				$varvalue[0] = trim($varvalue[0]);
				$varvalue[1] = trim($varvalue[1]);
				switch (strtolower($varvalue[0])) {
					case "dragging":
						$this->dragging = $varvalue[1];
						break;
					case "doubleclickzoom":
						$this->doubleClickZoom = $varvalue[1];
						break;
					case "continuouszoom":
						$this->continuousZoom = $varvalue[1];
						break;
					case "googlebar":
						$this->googleBar = $varvalue[1];
						break;
					case "scrollwheelzoom":
						$this->scrollWheelZoom = $varvalue[1];
						break;
					case "urldisplaymode":
						$this->urlDisplayMode = $varvalue[1];
						break;
					case "maptype":
						$this->viewStyle = $varvalue[1];
						break;
					case "width":
						if (is_numeric($varvalue[1])) {
							$this->width = intval($varvalue[1]);
						}
						break;
					case "height":
						if (is_numeric($varvalue[1])) {
							$this->height = intval($varvalue[1]);
						}
						break;
					case "align":
						$this->align = $varvalue[1];
						break;
					case "panzoomcontrol":
						$this->panZoomControl = $varvalue[1];
						break;
					case "overviewmapcontrol":
						$this->overViewMapControl = $varvalue[1];
						break;
					case "scalecontrol":
						$this->scaleControl = $varvalue[1];
						break;
					case "maptypecontrol":
						$this->mapTypeControl = $varvalue[1];
						break;
					case "mapnormal":
						$this->mapNormal = $varvalue[1];
						break;
					case "maphybrid":
						$this->mapHybrid = $varvalue[1];
						break;
					case "mapsat":
						$this->mapSatellite = $varvalue[1];
						break;
					case "mapearth":
						$this->mapEarth = $varvalue[1];
						break;
					case "mapphysical":
						$this->mapPhysical = $varvalue[1];
						break;
					case "gpxinterval":
						if (is_numeric($varvalue[1])) {
							$this->gpxInterval = intval($varvalue[1]);
						}
						break;
					case "gpxcheckpointtable":
						$this->gpxCheckpointTable = $varvalue[1];
						break;
					case "gpxcolor":
						$this->gpxLineColor = myFunctions::colorName2Hex($varvalue[1]);
						break;
					case "gpxelevationcolor":
						$this->gpxElevationLineColor = str_replace("#","",myFunctions::colorName2Hex($varvalue[1]));
						break;
					case "gpxelevation":
						$this->gpxElevationChart = $varvalue[1];
						break;
					case "gpxelevationmeasurement":
					case "measurement":
						$this->measurement = $varvalue[1];
						break;
					case "speedscale":
						$this->speedscale = $varvalue[1];
						break;
					case "gpxspeedchartcolor":
						$this->gpxSpeedLineColor = str_replace("#","",myFunctions::colorName2Hex($varvalue[1]));
						break;
					case "gpxspeedchart":
						$this->gpxSpeedChart = $varvalue[1];
						break;
					case "gpxlinewidth":
						if (is_numeric($varvalue[1])) {
							$this->gpxLineWidth = intval($varvalue[1]);
						}
						break;
					case "gpxelevationlinewidth":
						if (is_numeric($varvalue[1])) {
							$this->gpxElevationLineWidth = intval($varvalue[1]);
						}
						break;
					case "gpxelevationheight":
						if (is_numeric($varvalue[1])) {
							$this->gpxElevationChartHeight = intval($varvalue[1]);
						}
						break;
					case "gpxcheckpointinterval":
						if (is_numeric($varvalue[1])) {
							$this->gpxCheckpointInterval = floatval($varvalue[1]);
						}
						break;
					case "gpxcheckpointmarkercolor":
						$this->gpxCheckpointMarkerColor = $varvalue[1];
						break;
					case "gpxspeedchartlinewidth":
						if (is_numeric($varvalue[1])) {
							$this->gpxSpeedLineWidth = intval($varvalue[1]);
						}
						break;
					case "gpxspeedchartheight":
						if (is_numeric($varvalue[1])) {
							$this->gpxSpeedChartHeight = intval($varvalue[1]);
						}
						break;
					case "gpxlineopacity":
						if (is_numeric($varvalue[1])) {
							$this->gpxLineOpacity = intval($varvalue[1]);
						}
						break;
					case "gpxview":
						$this->gpxView = $varvalue[1];
						break;
					case "maxlat":
						if (is_numeric($varvalue[1])) {
							$this->maxLat = doubleval($varvalue[1]);
							$this->manualZoom++;
						}
						break;
					case "maxlon":
						if (is_numeric($varvalue[1])) {
							$this->maxLon = doubleval($varvalue[1]);
							$this->manualZoom++;
						}
						break;
					case "minlat":
						if (is_numeric($varvalue[1])) {
							$this->minLat = doubleval($varvalue[1]);
							$this->manualZoom++;
						}
						break;
					case "minlon":
						if (is_numeric($varvalue[1])) {
							$this->minLon = doubleval($varvalue[1]);
							$this->manualZoom++;
						}
						break;
					case "zoom":
						if (is_numeric($varvalue[1])) {
							$this->zoom = intval($varvalue[1]);
						}
						break;
					case "deltazoom":
						if (is_numeric($varvalue[1])) {
							$this->deltazoom = intval($varvalue[1]);
						}
						break;
				}
			}
		}
	}
}


class myFunctions {

	function seconds2Text($seconds) {
		$hours = floor($seconds / (60*60));
		$seconds -= $hours *(60*60);
		$minutes = floor($seconds / 60);
		$seconds -= $minutes*60;
		$seconds = floor($seconds);
		if ($hours != 0) {
			return  $hours."h ".str_pad($minutes,2,"0",STR_PAD_LEFT)."m ".str_pad($seconds,2,"0",STR_PAD_LEFT)."s";
		} else {
			if ($minutes != 0) {
				return $minutes."m ".str_pad($seconds,2,"0",STR_PAD_LEFT)."s";
			} else {
				return $seconds."s";
			}
		}
	}

	function getSpeedString($measurement,$scale,$distancekm,$timesec) {
		if ($timesec==0) {
			return "-";
		} else {
			switch (strtolower($measurement.$scale)) {
				case "imperiallevel2":
					return round(($distancekm/1.609344) / ($timesec/3600),2)." mph";
					break;
				case "imperiallevel1":
					return round(($distancekm/0.3048) / ($timesec),2)." fph";
					break;
				case "metriclevel1":
					return round(($distancekm*1000) / ($timesec),2)." m/s";
					break;
				default:
				case "metriclevel2":
					return round(($distancekm) / ($timesec/3600),2)." km/h";
					break;
			}
		}
	}

function distBetween2PointsKM($lat1, $lon1, $lat2, $lon2) {
	$lat1 = deg2rad($lat1);
	$lon1 = deg2rad($lon1);
	$lat2 = deg2rad($lat2);
	$lon2 = deg2rad($lon2);
	return rad2deg(acos(sin($lat1) * sin($lat2) + cos($lat1) * cos($lat2) * cos($lon2 - $lon1))) * 111.1206;
}

function xmlDate2DateTime($value) {
	$value = str_replace("Z","",$value);
	return strtotime($value);
}

function colorName2Hex($name) {
	switch (strtolower($name)) {
		case "aliceblue": return "#F0F8FF"; break;
		case "antiquewhite": return "#FAEBD7"; break;
		case "aqua": return "#00FFFF"; break;
		case "aquamarine": return "#7FFFD4"; break;
		case "azure": return "#F0FFFF"; break;
		case "beige": return "#F5F5DC"; break;
		case "bisque": return "#FFE4C4"; break;
		case "black": return "#000000"; break;
		case "blanchedalmond": return "#FFEBCD"; break;
		case "blue": return "#0000FF"; break;
		case "blueviolet": return "#8A2BE2"; break;
		case "brown": return "#A52A2A"; break;
		case "burlywood": return "#DEB887"; break;
		case "cadetblue": return "#5F9EA0"; break;
		case "chartreuse": return "#7FFF00"; break;
		case "chocolate": return "#D2691E"; break;
		case "coral": return "#FF7F50"; break;
		case "cornflowerblue": return "#6495ED"; break;
		case "cornsilk": return "#FFF8DC"; break;
		case "crimson": return "#DC143C"; break;
		case "cyan": return "#00FFFF"; break;
		case "darkblue": return "#00008B"; break;
		case "darkcyan": return "#008B8B"; break;
		case "darkgoldenrod": return "#B8860B"; break;
		case "darkgray": return "#A9A9A9"; break;
		case "darkgrey": return "#A9A9A9"; break;
		case "darkgreen": return "#006400"; break;
		case "darkkhaki": return "#BDB76B"; break;
		case "darkmagenta": return "#8B008B"; break;
		case "darkolivegreen": return "#556B2F"; break;
		case "darkorange": return "#FF8C00"; break;
		case "darkorchid": return "#9932CC"; break;
		case "darkred": return "#8B0000"; break;
		case "darksalmon": return "#E9967A"; break;
		case "darkseagreen": return "#8FBC8F"; break;
		case "darkslateblue": return "#483D8B"; break;
		case "darkslategray": return "#2F4F4F"; break;
		case "darkslategrey": return "#2F4F4F"; break;
		case "darkturquoise": return "#00CED1"; break;
		case "darkviolet": return "#9400D3"; break;
		case "deeppink": return "#FF1493"; break;
		case "deepskyblue": return "#00BFFF"; break;
		case "dimgray": return "#696969"; break;
		case "dimgrey": return "#696969"; break;
		case "dodgerblue": return "#1E90FF"; break;
		case "firebrick": return "#B22222"; break;
		case "floralwhite": return "#FFFAF0"; break;
		case "forestgreen": return "#228B22"; break;
		case "fuchsia": return "#FF00FF"; break;
		case "gainsboro": return "#DCDCDC"; break;
		case "ghostwhite": return "#F8F8FF"; break;
		case "gold": return "#FFD700"; break;
		case "goldenrod": return "#DAA520"; break;
		case "gray": return "#808080"; break;
		case "grey": return "#808080"; break;
		case "green": return "#008000"; break;
		case "greenyellow": return "#ADFF2F"; break;
		case "honeydew": return "#F0FFF0"; break;
		case "hotpink": return "#FF69B4"; break;
		case "indianred ": return "#CD5C5C"; break;
		case "indigo ": return "#4B0082"; break;
		case "ivory": return "#FFFFF0"; break;
		case "khaki": return "#F0E68C"; break;
		case "lavender": return "#E6E6FA"; break;
		case "lavenderblush": return "#FFF0F5"; break;
		case "lawngreen": return "#7CFC00"; break;
		case "lemonchiffon": return "#FFFACD"; break;
		case "lightblue": return "#ADD8E6"; break;
		case "lightcoral": return "#F08080"; break;
		case "lightcyan": return "#E0FFFF"; break;
		case "lightgoldenrodyellow": return "#FAFAD2"; break;
		case "lightgray": return "#D3D3D3"; break;
		case "lightgrey": return "#D3D3D3"; break;
		case "lightgreen": return "#90EE90"; break;
		case "lightpink": return "#FFB6C1"; break;
		case "lightsalmon": return "#FFA07A"; break;
		case "lightseagreen": return "#20B2AA"; break;
		case "lightskyblue": return "#87CEFA"; break;
		case "lightslategray": return "#778899"; break;
		case "lightslategrey": return "#778899"; break;
		case "lightsteelblue": return "#B0C4DE"; break;
		case "lightyellow": return "#FFFFE0"; break;
		case "lime": return "#00FF00"; break;
		case "limegreen": return "#32CD32"; break;
		case "linen": return "#FAF0E6"; break;
		case "magenta": return "#FF00FF"; break;
		case "maroon": return "#800000"; break;
		case "mediumaquamarine": return "#66CDAA"; break;
		case "mediumblue": return "#0000CD"; break;
		case "mediumorchid": return "#BA55D3"; break;
		case "mediumpurple": return "#9370D8"; break;
		case "mediumseagreen": return "#3CB371"; break;
		case "mediumslateblue": return "#7B68EE"; break;
		case "mediumspringgreen": return "#00FA9A"; break;
		case "mediumturquoise": return "#48D1CC"; break;
		case "mediumvioletred": return "#C71585"; break;
		case "midnightblue": return "#191970"; break;
		case "mintcream": return "#F5FFFA"; break;
		case "mistyrose": return "#FFE4E1"; break;
		case "moccasin": return "#FFE4B5"; break;
		case "navajowhite": return "#FFDEAD"; break;
		case "navy": return "#000080"; break;
		case "oldlace": return "#FDF5E6"; break;
		case "olive": return "#808000"; break;
		case "olivedrab": return "#6B8E23"; break;
		case "orange": return "#FFA500"; break;
		case "orangered": return "#FF4500"; break;
		case "orchid": return "#DA70D6"; break;
		case "palegoldenrod": return "#EEE8AA"; break;
		case "palegreen": return "#98FB98"; break;
		case "paleturquoise": return "#AFEEEE"; break;
		case "palevioletred": return "#D87093"; break;
		case "papayawhip": return "#FFEFD5"; break;
		case "peachpuff": return "#FFDAB9"; break;
		case "peru": return "#CD853F"; break;
		case "pink": return "#FFC0CB"; break;
		case "plum": return "#DDA0DD"; break;
		case "powderblue": return "#B0E0E6"; break;
		case "purple": return "#800080"; break;
		case "red": return "#FF0000"; break;
		case "rosybrown": return "#BC8F8F"; break;
		case "royalblue": return "#4169E1"; break;
		case "saddlebrown": return "#8B4513"; break;
		case "salmon": return "#FA8072"; break;
		case "sandybrown": return "#F4A460"; break;
		case "seagreen": return "#2E8B57"; break;
		case "seashell": return "#FFF5EE"; break;
		case "sienna": return "#A0522D"; break;
		case "silver": return "#C0C0C0"; break;
		case "skyblue": return "#87CEEB"; break;
		case "slateblue": return "#6A5ACD"; break;
		case "slategray": return "#708090"; break;
		case "slategrey": return "#708090"; break;
		case "snow": return "#FFFAFA"; break;
		case "springgreen": return "#00FF7F"; break;
		case "steelblue": return "#4682B4"; break;
		case "tan": return "#D2B48C"; break;
		case "teal": return "#008080"; break;
		case "thistle": return "#D8BFD8"; break;
		case "tomato": return "#FF6347"; break;
		case "turquoise": return "#40E0D0"; break;
		case "violet": return "#EE82EE"; break;
		case "wheat": return "#F5DEB3"; break;
		case "white": return "#FFFFFF"; break;
		case "whitesmoke": return "#F5F5F5"; break;
		case "yellow": return "#FFFF00"; break;
		case "yellowgreen": return "#9ACD32"; break;
		default: return $name; break;
	}
}
}
?>